## linux-lts-quantal 3.5.0-25.39~precise1+6.0trisquel1

=== Makefile ===
VERSION = 3
PATCHLEVEL = 5
SUBLEVEL = 7
EXTRAVERSION = .4-gnu
NAME = Saber-toothed Squirrel

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not:
# o  use make's built-in rules and variables
#    (this increases performance and avoids hard-to-debug behaviour);
# o  print "Entering directory ...";
MAKEFLAGS += -rR --no-print-directory

# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
# See the file "Documentation/sparse.txt" for more details, including
# where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif

ifeq ("$(origin M)", "command line")
  KBUILD_EXTMOD := $(M)
endif

# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

ifeq ("$(origin W)", "command line")
  export KBUILD_ENABLE_EXTRA_GCC_CHECKS := $(W)
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

# Cancel implicit rules on top Makefile
$(CURDIR)/Makefile Makefile: ;

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

PHONY += $(MAKECMDGOALS) sub-make

$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
	$(Q)@:

sub-make: FORCE
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT) \
	KBUILD_SRC=$(CURDIR) \
	KBUILD_EXTMOD="$(KBUILD_EXTMOD)" -f $(CURDIR)/Makefile \
	$(filter-out _all sub-make,$(MAKECMDGOALS))

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
PHONY += all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH


# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and 
# SUBARCH is subsequently ignored.

SUBARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
				  -e s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/s390x/s390/ -e s/parisc64/parisc/ \
				  -e s/ppc.*/powerpc/ -e s/mips.*/mips/ \
				  -e s/sh[234].*/sh/ )

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# A third alternative is to store a setting in .config so that plain
# "make" in the configured kernel build directory always uses that.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile
export KBUILD_BUILDHOST := $(SUBARCH)
ARCH		?= $(SUBARCH)
CROSS_COMPILE	?= $(CONFIG_CROSS_COMPILE:"%"=%)

# Architecture as present in compile.h
UTS_MACHINE 	:= $(ARCH)
SRCARCH 	:= $(ARCH)

# Additional ARCH settings for x86
ifeq ($(ARCH),i386)
        SRCARCH := x86
endif
ifeq ($(ARCH),x86_64)
        SRCARCH := x86
endif

# Additional ARCH settings for sparc
ifeq ($(ARCH),sparc32)
       SRCARCH := sparc
endif
ifeq ($(ARCH),sparc64)
       SRCARCH := sparc
endif

# Additional ARCH settings for sh
ifeq ($(ARCH),sh64)
       SRCARCH := sh
endif

# Additional ARCH settings for tile
ifeq ($(ARCH),tilepro)
       SRCARCH := tile
endif
ifeq ($(ARCH),tilegx)
       SRCARCH := tile
endif

# Where to locate arch specific headers
hdr-arch  := $(SRCARCH)

KCONFIG_CONFIG	?= .config
export KCONFIG_CONFIG

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC       = gcc
HOSTCXX      = g++
HOSTCFLAGS   = -Wall -Wmissing-prototypes -Wstrict-prototypes -O2 -fomit-frame-pointer
HOSTCXXFLAGS = -O2

# Decide whether to build built-in, modular, or both.
# Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are up to date before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed. 
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

# We need some generic definitions (do not try to remake the file).
$(srctree)/scripts/Kbuild.include: ;
include $(srctree)/scripts/Kbuild.include

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE)as
LD		= $(CROSS_COMPILE)ld
CC		= $(CROSS_COMPILE)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
INSTALLKERNEL  := installkernel
DEPMOD		= /sbin/depmod
PERL		= perl
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
		  -Wbitwise -Wno-return-void $(CF)
CFLAGS_MODULE   =
AFLAGS_MODULE   =
LDFLAGS_MODULE  =
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=
CFLAGS_GCOV	= -fprofile-arcs -ftest-coverage

# Prefer linux-backports-modules
ifneq ($(KBUILD_SRC),)
ifneq ($(shell if test -e $(KBUILD_OUTPUT)/ubuntu-build; then echo yes; fi),yes)
UBUNTUINCLUDE := -I/usr/src/linux-headers-lbm-$(KERNELRELEASE)
endif
endif

# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
LINUXINCLUDE    := $(UBUNTUINCLUDE) -I$(srctree)/arch/$(hdr-arch)/include \
                   -Iarch/$(hdr-arch)/include/generated -Iinclude \
                   $(if $(KBUILD_SRC), -I$(srctree)/include) \
                   -include $(srctree)/include/linux/kconfig.h

# UBUNTU: Include our third party driver stuff too
LINUXINCLUDE   += -Iubuntu/include $(if $(KBUILD_SRC),-I$(srctree)/ubuntu/include)

KBUILD_CPPFLAGS := -D__KERNEL__

KBUILD_CFLAGS   := -Wall -Wundef -Wstrict-prototypes -Wno-trigraphs \
		   -fno-strict-aliasing -fno-common \
		   -Werror-implicit-function-declaration \
		   -Wno-format-security \
		   -fno-delete-null-pointer-checks
KBUILD_AFLAGS_KERNEL :=
KBUILD_CFLAGS_KERNEL :=
KBUILD_AFLAGS   := -D__ASSEMBLY__
KBUILD_AFLAGS_MODULE  := -DMODULE
KBUILD_CFLAGS_MODULE  := -DMODULE
KBUILD_LDFLAGS_MODULE := -T $(srctree)/scripts/module-common.lds

# Read KERNELRELEASE from include/config/kernel.release (if it exists)
KERNELRELEASE = $(shell cat include/config/kernel.release 2> /dev/null)
KERNELVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)

export VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION

=== firmware/Makefile ===
#
# kbuild file for firmware/
#

# Create $(fwabs) from $(CONFIG_EXTRA_FIRMWARE_DIR) -- if it doesn't have a
# leading /, it's relative to $(srctree).
fwdir := $(subst ",,$(CONFIG_EXTRA_FIRMWARE_DIR))
fwabs := $(addprefix $(srctree)/,$(filter-out /%,$(fwdir)))$(filter /%,$(fwdir))

fw-external-y := $(subst ",,$(CONFIG_EXTRA_FIRMWARE))

# There are three cases to care about:
# 1. Building kernel with CONFIG_FIRMWARE_IN_KERNEL=y -- $(fw-shipped-y) should
#    include the firmware files to include, according to .config
# 2. 'make modules_install', which will install firmware for modules, and 
#    _also_ for the in-kernel drivers when CONFIG_FIRMWARE_IN_KERNEL=n
# 3. 'make firmware_install', which installs all firmware, unconditionally.

# For the former two cases we want $(fw-shipped-y) and $(fw-shipped-m) to be
# accurate. In the latter case it doesn't matter -- it'll use $(fw-shipped-all).
# But be aware that the config file might not be included at all.

ifdef CONFIG_ACENIC_OMIT_TIGON_I
acenic-objs := $(DEBLOBBED)
fw-shipped- += $(DEBLOBBED)
else
acenic-objs := $(DEBLOBBED) $(DEBLOBBED)
endif
fw-shipped-$(CONFIG_ACENIC) += $(acenic-objs)
fw-shipped-$(CONFIG_ATARI_DSP56K) += dsp56k/bootstrap.bin
fw-shipped-$(CONFIG_BNX2X) += $(DEBLOBBED) \
			      $(DEBLOBBED) \
			      $(DEBLOBBED)
fw-shipped-$(CONFIG_BNX2) += 	$(DEBLOBBED) \
				$(DEBLOBBED) \
				$(DEBLOBBED) \
				$(DEBLOBBED) \
				$(DEBLOBBED)
fw-shipped-$(CONFIG_E100) += $(DEBLOBBED) $(DEBLOBBED) \
			     $(DEBLOBBED)
fw-shipped-$(CONFIG_PCMCIA_PCNET) += 
				     
fw-shipped-$(CONFIG_PCMCIA_3C589) += 
fw-shipped-$(CONFIG_PCMCIA_3C574) += 
fw-shipped-$(CONFIG_SERIAL_8250_CS) +=
				       
fw-shipped-$(CONFIG_SCSI_QLOGIC_1280) += $(DEBLOBBED) $(DEBLOBBED) \
					 $(DEBLOBBED)
fw-shipped-$(CONFIG_SCSI_QLOGICPTI) += $(DEBLOBBED)
fw-shipped-$(CONFIG_INFINIBAND_QIB) += $(DEBLOBBED)
fw-shipped-$(CONFIG_SND_WAVEFRONT) += $(DEBLOBBED)
fw-shipped-$(CONFIG_TIGON3) += $(DEBLOBBED) $(DEBLOBBED) \
			       $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_DABUSB) += $(DEBLOBBED) $(DEBLOBBED)
ifdef CONFIG_FIRMWARE_IN_KERNEL
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_MPR) += $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_USA18X) += $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_USA19) += $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_USA19QI) += $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_USA19QW) += $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_USA19W) += $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_USA28) += $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_USA28XA) += $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_USA28XB) += $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_USA28X) += $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_USA49W) += $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_SERIAL_KEYSPAN_USA49WLC) += $(DEBLOBBED)
else
fw-shipped- += $(DEBLOBBED) $(DEBLOBBED) $(DEBLOBBED)	\
	$(DEBLOBBED) $(DEBLOBBED) $(DEBLOBBED)		\
	$(DEBLOBBED) $(DEBLOBBED) $(DEBLOBBED)		\
	$(DEBLOBBED) $(DEBLOBBED) $(DEBLOBBED)
endif
fw-shipped-$(CONFIG_USB_SERIAL_WHITEHEAT) += $(DEBLOBBED) $(DEBLOBBED) \
					   # $(DEBLOBBED)
fw-shipped-$(CONFIG_USB_VICAM) += $(DEBLOBBED)
fw-shipped-$(CONFIG_YAM) += $(DEBLOBBED) $(DEBLOBBED)

fw-shipped-$(CONFIG_SCSI_QLA_FC) += \
	$(DEBLOBBED) \
	$(DEBLOBBED) \
	$(DEBLOBBED) \
	$(DEBLOBBED)

fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)
fw-shipped-$(CONFIG_DRM_RADEON) += $(DEBLOBBED)

fw-shipped-all := $(fw-shipped-y) $(fw-shipped-m) $(fw-shipped-)

# Directories which we _might_ need to create, so we have a rule for them.
firmware-dirs := $(sort $(addprefix $(objtree)/$(obj)/,$(dir $(fw-external-y) $(fw-shipped-all))))

quiet_cmd_mkdir = MKDIR   $(patsubst $(objtree)/%,%,$@)
      cmd_mkdir = mkdir -p $@

quiet_cmd_ihex  = IHEX    $@
      cmd_ihex  = $(OBJCOPY) -Iihex -Obinary $< $@

quiet_cmd_ihex2fw  = IHEX2FW $@
      cmd_ihex2fw  = $(objtree)/$(obj)/ihex2fw $< $@

quiet_cmd_h16tofw  = H16TOFW $@
      cmd_h16tofw  = $(objtree)/$(obj)/ihex2fw -w $< $@

quiet_cmd_fwbin = MK_FW   $@
      cmd_fwbin = FWNAME="$(patsubst firmware/%.gen.S,%,$@)";		     \
		  FWSTR="$(subst /,_,$(subst .,_,$(subst -,_,$(patsubst	     \
				firmware/%.gen.S,%,$@))))";		     \
		  ASM_WORD=$(if $(CONFIG_64BIT),.quad,.long);		     \
		  ASM_ALIGN=$(if $(CONFIG_64BIT),3,2);			     \
		  PROGBITS=$(if $(CONFIG_ARM),%,@)progbits;		     \
		  echo "/* Generated by firmware/Makefile */"		> $@;\
		  echo "    .section .rodata"				>>$@;\
		  echo "    .p2align $${ASM_ALIGN}"			>>$@;\
		  echo "_fw_$${FWSTR}_bin:"				>>$@;\
		  echo "    .incbin \"$(2)\""				>>$@;\
		  echo "_fw_end:"					>>$@;\
		  echo "   .section .rodata.str,\"aMS\",$${PROGBITS},1"	>>$@;\
		  echo "    .p2align $${ASM_ALIGN}"			>>$@;\
		  echo "_fw_$${FWSTR}_name:"				>>$@;\
		  echo "    .string \"$$FWNAME\""			>>$@;\
		  echo "    .section .builtin_fw,\"a\",$${PROGBITS}"	>>$@;\
		  echo "    .p2align $${ASM_ALIGN}"			>>$@;\
		  echo "    $${ASM_WORD} _fw_$${FWSTR}_name"		>>$@;\
		  echo "    $${ASM_WORD} _fw_$${FWSTR}_bin"		>>$@;\
		  echo "    $${ASM_WORD} _fw_end - _fw_$${FWSTR}_bin"	>>$@;

# One of these files will change, or come into existence, whenever
# the configuration changes between 32-bit and 64-bit. The .S files
# need to change when that happens.
wordsize_deps := $(wildcard include/config/64bit.h include/config/32bit.h \
		include/config/ppc32.h include/config/ppc64.h \
		include/config/superh32.h include/config/superh64.h \
		include/config/x86_32.h include/config/x86_64.h)

# Workaround for make < 3.81, where .SECONDEXPANSION doesn't work.
# It'll end up depending on these targets, so make them a PHONY rule which
# depends on _all_ the directories in $(firmware-dirs), and it'll work out OK.
PHONY += $(objtree)/$$(%) $(objtree)/$(obj)/$$(%)
$(objtree)/$$(%) $(objtree)/$(obj)/$$(%): $(firmware-dirs)
	@true

# For the $$(dir %) trick, where we need % to be expanded first.
.SECONDEXPANSION:

$(patsubst %,$(obj)/%.gen.S, $(fw-shipped-y)): %: $(wordsize_deps) \
		| $(objtree)/$$(dir %)
	$(call cmd,fwbin,$(patsubst %.gen.S,%,$@))
$(patsubst %,$(obj)/%.gen.S, $(fw-external-y)): %: $(wordsize_deps) \
		include/config/extra/firmware/dir.h | $(objtree)/$$(dir %)
	$(call cmd,fwbin,$(fwabs)/$(patsubst $(obj)/%.gen.S,%,$@))

# The .o files depend on the binaries directly; the .S files don't.
$(patsubst %,$(obj)/%.gen.o, $(fw-shipped-y)): %.gen.o: %
$(patsubst %,$(obj)/%.gen.o, $(fw-external-y)): $(obj)/%.gen.o: $(fwdir)/%

# .ihex is used just as a simple way to hold binary files in a source tree
# where binaries are frowned upon. They are directly converted with objcopy.
$(obj)/%: $(obj)/%.ihex | $(objtree)/$(obj)/$$(dir %)
	$(call cmd,ihex)

# Don't depend on ihex2fw if we're installing and it already exists.
# Putting it after | in the dependencies doesn't seem sufficient when
# we're installing after a cross-compile, because ihex2fw has dependencies
# on stuff like /usr/lib/gcc/ppc64-redhat-linux/4.3.0/include/stddef.h and 
# thus wants to be rebuilt. Which it can't be, if the prebuilt kernel tree
# is exported read-only for someone to run 'make install'.
ifeq ($(INSTALL):$(wildcard $(obj)/ihex2fw),install:$(obj)/ihex2fw)
ihex2fw_dep :=
else
ihex2fw_dep := $(obj)/ihex2fw
endif

# .HEX is also Intel HEX, but where the offset and length in each record
# is actually meaningful, because the firmware has to be loaded in a certain
# order rather than as a single binary blob. Thus, we convert them into our
# more compact binary representation of ihex records (<linux/ihex.h>)
$(obj)/%.fw: $(obj)/%.HEX $(ihex2fw_dep) | $(objtree)/$(obj)/$$(dir %)
	$(call cmd,ihex2fw)

# .H16 is our own modified form of Intel HEX, with 16-bit length for records.
$(obj)/%.fw: $(obj)/%.H16 $(ihex2fw_dep) | $(objtree)/$(obj)/$$(dir %)
	$(call cmd,h16tofw)

$(firmware-dirs):
	$(call cmd,mkdir)

obj-y				 += $(patsubst %,%.gen.o, $(fw-external-y))
obj-$(CONFIG_FIRMWARE_IN_KERNEL) += $(patsubst %,%.gen.o, $(fw-shipped-y))

# Remove .S files and binaries created from ihex
# (during 'make clean' .config isn't included so they're all in $(fw-shipped-))
targets := $(fw-shipped-) $(patsubst $(obj)/%,%, \
				$(shell find $(obj) -name \*.gen.S 2>/dev/null))

# Without this, built-in.o won't be created when it's empty, and the
# final vmlinux link will fail.
obj-n := dummy

hostprogs-y := ihex2fw

=== debian/control ===
Source: linux-lts-quantal
Section: devel
Priority: optional
Maintainer: Ubuntu Kernel Team <kernel-team@lists.ubuntu.com>
Standards-Version: 3.8.4.0
Build-Depends: debhelper (>= 5), cpio, module-init-tools, kernel-wedge (>= 2.24ubuntu1), makedumpfile [amd64 i386], device-tree-compiler [powerpc], libelf-dev, libnewt-dev, binutils-dev, rsync, libdw-dev, dpkg (>= 1.16.0~ubuntu4), util-linux, pkg-config, flex, bison
Build-Depends-Indep: xmlto, docbook-utils, ghostscript, transfig, bzip2, sharutils, asciidoc
Build-Conflicts: findutils (= 4.4.1-1ubuntu1)
Vcs-Git: http://kernel.ubuntu.com/git-repos/ubuntu/ubuntu-precise.git

Package: linux-headers-3.5.0-25
Architecture: all
Section: devel
Priority: optional
Depends: ${misc:Depends}, coreutils | fileutils (>= 4.0)
Description: Header files related to Linux kernel version 3.5.0
 This package provides kernel header files for version 3.5.0, for sites
 that want the latest kernel headers. Please read
 /usr/share/doc/linux-lts-quantal-headers-3.5.0-25/debian.README.gz for details

Package: linux-tools-3.5.0-25
Architecture: i386 amd64
Section: devel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, linux-tools-common
Description: Linux kernel version specific tools for version 3.5.0-25
 This package provides the architecture dependant parts for kernel
 version locked tools (such as perf and x86_energy_perf_policy) for
 version 3.5.0-25 on
 64 bit x86.



Package: linux-image-3.5.0-25-generic
Architecture: i386 amd64
Section: kernel
Priority: optional
Pre-Depends: dpkg (>= 1.10.24)
Depends: ${misc:Depends}, ${shlibs:Depends}, initramfs-tools (>= 0.36ubuntu6), module-init-tools (>= 3.3-pre11-4ubuntu3), crda (>=1.1.1-1ubuntu2) | wireless-crda
Conflicts: hotplug (<< 0.0.20040105-1)
Recommends: grub-pc | grub-efi-amd64 | grub-efi-ia32 | grub | lilo (>= 19.1)
Suggests: fdutils, linux-lts-quantal-doc-3.5.0 | linux-lts-quantal-source-3.5.0, linux-lts-quantal-tools
Description: Linux kernel image for version 3.5.0 on 64 bit x86 SMP
 This package contains the Linux kernel image for version 3.5.0 on
 64 bit x86 SMP.
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports Generic processors.
 .
 Geared toward desktop and server systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-generic meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-image-extra-3.5.0-25-generic
Architecture: i386 amd64
Section: kernel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, linux-image-3.5.0-25-generic
Description: Linux kernel image for version 3.5.0 on 64 bit x86 SMP
 This package contains the Linux kernel image for version 3.5.0 on
 64 bit x86 SMP.
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports Generic processors.
 .
 Geared toward desktop and server systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-generic meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.

Package: linux-headers-3.5.0-25-generic
Architecture: i386 amd64
Section: devel
Priority: optional
Depends: ${misc:Depends}, linux-headers-3.5.0-25, ${shlibs:Depends}
Description: Linux kernel headers for version 3.5.0 on 64 bit x86 SMP
 This package provides kernel header files for version 3.5.0 on
 64 bit x86 SMP.
 .
 This is for sites that want the latest kernel headers.  Please read
 /usr/share/doc/linux-lts-quantal-headers-3.5.0-25/debian.README.gz for details.

Package: linux-image-3.5.0-25-generic-dbgsym
Architecture: i386 amd64
Section: devel
Priority: optional
Depends: ${misc:Depends}
Description: Linux kernel debug image for version 3.5.0 on 64 bit x86 SMP
 This package provides a kernel debug image for version 3.5.0 on
 64 bit x86 SMP.
 .
 This is for sites that wish to debug the kernel.
 .
 The kernel image contained in this package is NOT meant to boot from. It
 is uncompressed, and unstripped. This package also includes the
 unstripped modules.

Package: kernel-image-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: kernel-image
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: extra
Description: Linux kernel binary image for the Debian installer
 This package contains the kernel image for the Debian installer
 boot images. It does _not_ provide a usable kernel for your full
 Debian system.

Package: nic-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: nic-modules
Depends: kernel-image-3.5.0-25-generic-di, nic-shared-modules-3.5.0-25-generic-di, virtio-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: Network interface support

Package: nic-shared-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: nic-shared-modules
Depends: kernel-image-3.5.0-25-generic-di, crypto-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: nic shared modules
  This package contains modules which support nic modules

Package: serial-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: serial-modules
Depends: kernel-image-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: Serial port support

Package: ppp-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: ppp-modules
Depends: kernel-image-3.5.0-25-generic-di, nic-shared-modules-3.5.0-25-generic-di, serial-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: PPP (serial port) networking support

Package: pata-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: pata-modules
Depends: kernel-image-3.5.0-25-generic-di, storage-core-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: PATA support modules

Package: firewire-core-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: firewire-core-modules
Depends: kernel-image-3.5.0-25-generic-di, storage-core-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: Firewire (IEEE-1394) Support

Package: scsi-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: scsi-modules
Depends: kernel-image-3.5.0-25-generic-di, storage-core-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: SCSI storage support

Package: plip-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: plip-modules
Depends: kernel-image-3.5.0-25-generic-di, nic-shared-modules-3.5.0-25-generic-di, parport-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: PLIP (parallel port) networking support

Package: floppy-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: floppy-modules
Depends: kernel-image-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: Floppy driver support

Package: fat-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: fat-modules
Depends: kernel-image-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: FAT filesystem support
 This includes Windows FAT and VFAT support.

Package: nfs-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: nfs-modules
Depends: kernel-image-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: NFS filesystem drivers
 Includes the NFS client driver, and supporting modules.

Package: md-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: md-modules
Depends: kernel-image-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: Multi-device support (raid, device-mapper, lvm)

Package: multipath-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: multipath-modules
Depends: kernel-image-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: extra
Description: DM-Multipath support
  This package contains modules for device-mapper multipath support.

Package: usb-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: usb-modules
Depends: kernel-image-3.5.0-25-generic-di, storage-core-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: Core USB support

Package: pcmcia-storage-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: pcmcia-storage-modules
Depends: kernel-image-3.5.0-25-generic-di, scsi-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: PCMCIA storage support

Package: fb-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: fb-modules
Depends: kernel-image-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: Framebuffer modules

Package: input-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: input-modules
Depends: kernel-image-3.5.0-25-generic-di, usb-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: Support for various input methods

Package: mouse-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: mouse-modules
Depends: kernel-image-3.5.0-25-generic-di, input-modules-3.5.0-25-generic-di, usb-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: extra
Description: Mouse support
 This package contains mouse drivers for the Linux kernel.

Package: irda-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: irda-modules
Depends: kernel-image-3.5.0-25-generic-di, nic-shared-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: Support for Infrared protocols

Package: parport-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: parport-modules
Depends: kernel-image-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: Parallel port support

Package: nic-pcmcia-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: nic-pcmcia-modules
Depends: kernel-image-3.5.0-25-generic-di, nic-shared-modules-3.5.0-25-generic-di, nic-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: PCMCIA network interface support

Package: pcmcia-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: pcmcia-modules
Depends: kernel-image-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
Section: debian-installer
Priority: standard
Description: PCMCIA Modules

Package: nic-usb-modules-3.5.0-25-generic-di
XC-Package-Type: udeb
Provides: nic-usb-modules
Depends: kernel-image-3.5.0-25-generic-di, nic-shared-modules-3.5.0-25-generic-di, usb-modules-3.5.0-25-generic-di
Architecture: amd64
XB-Kernel-Version: 3.5.0-25-generic
